{
module Lexer where

}

%wrapper "basic"

$digit	    = 0-9
$alpha      = [ A-Z a-z ]
$alphanum   = [ $alpha $digit _ ' ]

tokens :-

   $white+                              ;
   "--"[^v].*                           ;
   "--"v[^i].*                          ;
   "--"vi[^s].*                         ;
   "--"vis[^i].*                        ;
   "--"visi[^t].*                       ;
   "--"visit[^o].*                      ;
   "--"visito[^r].*                     ;
   "--visitor"                          { \ _ -> TkVisitor }
   data			                { \ _ -> TkData }
   \|			                { \s -> TkBar }
   [$alpha $digit \_ \' \< \>]+	        { TkId }
   \,			                { \ _ -> TkComma }
   \;			                { \ _ -> TkSemi }
   \:\:			                { \ _ -> TkColon }
   \=			                { \ _ -> TkEqual }
   \{			                { \ _ -> TkOpenBrace }
   \}			                { \ _ -> TkCloseBrace }
   \[			                { \ _ -> TkOpenSquare }
   \]			                { \ _ -> TkCloseSquare }
   \(			                { \ _ -> TkOpenParen }
   \)			                { \ _ -> TkCloseParen }
        

{

data Token  = TkId String 
	    | TkComma | TkSemi | TkBar
            | TkData | TkVisitor
	    | TkOpenBrace | TkCloseBrace 
	    | TkOpenSquare | TkCloseSquare 
	    | TkOpenParen | TkCloseParen 
	    | TkEqual | TkColon    
	    | TkEOF
    deriving Show

}
